unit USAGESBD;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, DB, ADODB, ExtCtrls, ComCtrls, Mask, DBCtrls;

type
  TFBANCODEDADOS = class(TForm)
    btnCriarUsuario: TBitBtn;
    conexao: TADOConnection;
    qconexao: TADOQuery;
    cnn: TLabel;
    btnCriarDatabase: TButton;
    dsconexao: TDataSource;
    procedure FormCreate(Sender: TObject);
    procedure btnCriarUsuarioClick(Sender: TObject);
    procedure btnCriarDatabaseClick(Sender: TObject);
    

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FBANCODEDADOS: TFBANCODEDADOS;

implementation

{$R *.dfm}

procedure TFBANCODEDADOS.FormCreate(Sender: TObject);
begin
 //PASSO - 01
 conexao.ConnectionString := 'Provider=MSDASQL.1;Persist Security Info=False;' +
 'Extended Properties="DRIVER={PostgreSQL Unicode};DATABASE=template1;SERVER=localhost;PORT=5432;' +
 'UID=postgres;PWD=abcd;SSLmode=disable;ReadOnly=0;Protocol=7.4;FakeOidIndex=0;' +
 'ShowOidColumn=0;RowVersioning=0;ShowSystemTables=0;ConnSettings=;Fetch=100;Socket=4096;' +
 'UnknownSizes=0;MaxVarcharSize=255;MaxLongVarcharSize=8190;Debug=0;CommLog=0;Optimizer=0;' +
 'Ksqo=1;UseDeclareFetch=0;TextAsLongVarchar=1;UnknownsAsLongVarchar=0;BoolsAsChar=1;' +
 'Parse=0;CancelAsFreeStmt=0;ExtraSysTablePrefixes=dd_;LFConversion=1;UpdatableCursors=1;' +
 'DisallowPremature=0;TrueIsMinus1=0;BI=0;ByteaAsLongVarBinary=0;UseServerSidePrepare=0;' +
 'LowerCaseIdentifier=0;XaOpt=1"';

end;


procedure TFBANCODEDADOS.btnCriarUsuarioClick(Sender: TObject);
begin

 //PASSO - 02
  qconexao.Close;
  qconexao.SQL.Clear;
  qconexao.SQL.Add('CREATE ROLE suporte LOGIN ENCRYPTED PASSWORD ''123456'' SUPERUSER INHERIT CREATEDB CREATEROLE;');
  qconexao.Prepared := True;
  qconexao.ExecSQL;
  qconexao.Active := False;

  btnCriarUsuario.Enabled := False;
  btnCriarDatabase.Click;

end;


procedure TFBANCODEDADOS.btnCriarDatabaseClick(Sender: TObject);
begin
  //PASSO - 03
  btnCriarDatabase.Enabled := False;
  qconexao.Close;
  qconexao.SQL.Clear;
  qconexao.SQL.Add('CREATE DATABASE "dbTeste"' +
                           ' WITH OWNER = "suporte"' +
                           ' ENCODING = ''UTF8''' +
                           ' TABLESPACE = "pg_default"');
  qconexao.Prepared := True;
  qconexao.ExecSQL;

 {
  Abaixo, sero criados os esquemas
  Observao: aqui trocamos de usurio postgres para o usurio suporte e, ento,
  criamos os esquemas, tabelas, chaves primrias/estrangeiras, insero de dados.
 }
 conexao.ConnectionString := 'Provider=MSDASQL.1;Persist Security Info=False;' +
 'Extended Properties="DRIVER={PostgreSQL Unicode};DATABASE=dbTeste;SERVER=localhost;PORT=5432;' +
 'UID=suporte;PWD=123456;SSLmode=disable;ReadOnly=0;Protocol=7.4;FakeOidIndex=0;' +
 'ShowOidColumn=0;RowVersioning=0;ShowSystemTables=0;ConnSettings=;Fetch=100;Socket=4096;' +
 'UnknownSizes=0;MaxVarcharSize=255;MaxLongVarcharSize=8190;Debug=0;CommLog=0;Optimizer=0;' +
 'Ksqo=1;UseDeclareFetch=0;TextAsLongVarchar=1;UnknownsAsLongVarchar=0;BoolsAsChar=1;' +
 'Parse=0;CancelAsFreeStmt=0;ExtraSysTablePrefixes=dd_;LFConversion=1;UpdatableCursors=1;' +
 'DisallowPremature=0;TrueIsMinus1=0;BI=0;ByteaAsLongVarBinary=0;UseServerSidePrepare=0;' +
 'LowerCaseIdentifier=0;XaOpt=1"';

  qconexao.Close;
  qconexao.SQL.Clear;
  qconexao.SQL.Add('CREATE SCHEMA "esquema_principal" AUTHORIZATION "suporte"');
  qconexao.Prepared := True;
  qconexao.ExecSQL;


 //Aqui, criamos as tabelas

  qconexao.Close;
  qconexao.SQL.Clear;
  qconexao.SQL.Add('CREATE TABLE "esquema_principal"."tbcadastro" (' +
  ' "dt_lanc" DATE DEFAULT now() NOT NULL,' +
  ' "hr_lanc" TIME WITHOUT TIME ZONE DEFAULT now() NOT NULL,' +
  ' "cpf" VARCHAR(11) NOT NULL,' +
  ' "nome" VARCHAR(50) NOT NULL,' +
  ' "ativo" CHAR(1) DEFAULT ''S'' NOT NULL' +
  ') WITH OIDS;');
  qconexao.Prepared := True;
  qconexao.ExecSQL;


  //aqui, so definidas as chaves primrias e estrangeiras (sugiro copiar/colar o cdigo
  // ALTER TABLE .... do gerenciador de banco de dados que voc estiver usando.

  qconexao.Close;
  qconexao.SQL.Clear;
  qconexao.SQL.Add('ALTER TABLE ONLY "esquema_principal"."tbcadastro"' +
    ' ADD CONSTRAINT "tbcadastro_pkey" PRIMARY KEY ("cpf");');
  qconexao.Prepared := True;
  qconexao.ExecSQL;


  //Nesse rea, a incluso dos dados bsicos
  qconexao.Close;
  qconexao.SQL.Clear;
  qconexao.SQL.Add('INSERT INTO "esquema_principal"."tbcadastro" ("dt_lanc","hr_lanc","cpf","nome","ativo") VALUES' +
                   ' (now(),now(),''00000000000'',''JOAO DA SILVA'',''S'');');
  qconexao.Prepared := True;
  qconexao.ExecSQL;

  Application.MessageBox('Processo concludo com sucesso!','PROJETO TESTE', MB_ICONEXCLAMATION);
  Application.Terminate;

end;


end.
